﻿package  
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.KeyboardEvent;
	import flash.text.TextField;
	import flash.text.TextFieldAutoSize;
	import flash.text.TextFormat;
	import flash.ui.Keyboard;
	
	public class CountDownDigit extends TextField
	{
		
		private const RUNNING:uint = 0;
		private const PAUSE:uint = 1;
		private const READY:uint = 2;
		private const SETTING:uint = 3;

		private const GREEN:uint = 0x00ff00;
		private const YELLOW:uint = 0xffff00;
		private const RED:uint = 0xff0000;

		private var startTime:Date;
		private var msInit:uint;
		private var container:Sprite;
		
		private var currentState:uint;
		private var yellow:uint;
		private var lossTime:uint;
		private var pauseTime:uint;

		private function keyDownHandler(event:KeyboardEvent):void {
			
			switch(currentState) {
				case RUNNING:
					onRunningState(event.keyCode);
					break;
				case READY:
					onReadyState(event.keyCode);
					break;
				case PAUSE:
					onPauseState(event.keyCode);
					break;
				case SETTING:
					//onSettingStage(event.KeyCode);
					break;
			}
		}
		
		private function onReadyState(keyCode:uint):void {
			
			switch(keyCode) {
				case Keyboard.ENTER:
					timeInit();
					container.addEventListener(Event.ENTER_FRAME, update);
					currentState = RUNNING;
					break;
				
			}
		}
		
		
		private function onPauseState(keyCode:uint):void {
			
			switch(keyCode) {
				case Keyboard.ENTER:					
					reset();
					currentState = READY;
					break;
				default:
					container.addEventListener(Event.ENTER_FRAME, update);
					currentState = RUNNING;
					lossTime += (new Date()).time - pauseTime;
			}
				
		}
		
		private function onRunningState(keyCode:uint):void {

			
			switch(keyCode) {
//				case Keyboard.ENTER:					
//					reset();
//					currentState = READY;
//					break;
				default:
					container.removeEventListener(Event.ENTER_FRAME, update);
					currentState = PAUSE;
					pauseTime = (new Date()).time;
			}
		}

		
		public function CountDownDigit(minutes:uint, yellow:uint, container:Sprite) 
		{
			msInit = minutes * 60 * 1000;
			this.container = container;
			this.yellow = yellow;
			currentState = READY;
			
			textInit();
			reset();
			
			container.stage.addEventListener(KeyboardEvent.KEY_DOWN, keyDownHandler);
			container.addChild(this);
		}
		
		
		private function timeInit():void {
			startTime = new Date();
		}
		
		
		private function textInit():void {
			
			x = container.stage.stageWidth / 2 - width / 2;;
			y = container.stage.stageHeight / 2 - height / 2;
			
			autoSize = TextFieldAutoSize.CENTER;
			var format:TextFormat = new TextFormat();
			format.font = "_ゴシック";
			format.size = 256;
			defaultTextFormat = format;
		}
		
		private function reset():void {
			textColor = GREEN;
			lossTime = 0;
			text = millisToString(msInit);
		}
		
		private function update(event:Event):void {
			var currentTime:Date = new Date();

			var preMillis:int = msInit - (currentTime.getTime() - startTime.getTime()) + lossTime;

			textColor = (preMillis > 0) ? ((preMillis > 60000 * yellow) ? GREEN : YELLOW) : RED;
			
			text = millisToString(Math.abs(preMillis));
		}
		
		private function millisToString(millis:uint):String {
						
			var minutes:uint = millis / (1000 * 60);
			var seconds:uint = (millis / 1000) % 60;
			
			var ms:String = (minutes < 10) ? "0" : "";
			var ss:String = (seconds < 10) ? "0" : "";
			
			return (new String(ms + minutes + " : " + ss + seconds));
		}
		
	}
	
}
